<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeperSaslServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ZooKeeperSaslServer.java</span></div><h1>ZooKeeperSaslServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.security.Principal;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;

import javax.security.auth.Subject;
import javax.security.sasl.Sasl;
import javax.security.sasl.SaslException;
import javax.security.sasl.SaslServer;

import org.apache.zookeeper.Login;
import org.ietf.jgss.GSSContext;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSException;
import org.ietf.jgss.GSSManager;
import org.ietf.jgss.GSSName;
import org.ietf.jgss.Oid;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ZooKeeperSaslServer {
    public static final String LOGIN_CONTEXT_NAME_KEY = &quot;zookeeper.sasl.serverconfig&quot;;
    public static final String DEFAULT_LOGIN_CONTEXT_NAME = &quot;Server&quot;;

<span class="fc" id="L44">    Logger LOG = LoggerFactory.getLogger(ZooKeeperSaslServer.class);</span>
    private SaslServer saslServer;

<span class="fc" id="L47">    ZooKeeperSaslServer(final Login login) {</span>
<span class="fc" id="L48">        saslServer = createSaslServer(login);</span>
<span class="fc" id="L49">    }</span>

    private SaslServer createSaslServer(final Login login) {
<span class="fc" id="L52">        synchronized (login) {</span>
<span class="fc" id="L53">            Subject subject = login.getSubject();</span>
<span class="pc bpc" id="L54" title="1 of 2 branches missed.">            if (subject != null) {</span>
                // server is using a JAAS-authenticated subject: determine service principal name and hostname from zk server's subject.
<span class="pc bpc" id="L56" title="1 of 2 branches missed.">                if (subject.getPrincipals().size() &gt; 0) {</span>
                    try {
<span class="nc" id="L58">                        final Object[] principals = subject.getPrincipals().toArray();</span>
<span class="nc" id="L59">                        final Principal servicePrincipal = (Principal)principals[0];</span>

                        // e.g. servicePrincipalNameAndHostname := &quot;zookeeper/myhost.foo.com@FOO.COM&quot;
<span class="nc" id="L62">                        final String servicePrincipalNameAndHostname = servicePrincipal.getName();</span>

<span class="nc" id="L64">                        int indexOf = servicePrincipalNameAndHostname.indexOf(&quot;/&quot;);</span>

                        // e.g. servicePrincipalName := &quot;zookeeper&quot;
<span class="nc" id="L67">                        final String servicePrincipalName = servicePrincipalNameAndHostname.substring(0, indexOf);</span>

                        // e.g. serviceHostnameAndKerbDomain := &quot;myhost.foo.com@FOO.COM&quot;
<span class="nc" id="L70">                        final String serviceHostnameAndKerbDomain = servicePrincipalNameAndHostname.substring(indexOf+1,servicePrincipalNameAndHostname.length());</span>

<span class="nc" id="L72">                        indexOf = serviceHostnameAndKerbDomain.indexOf(&quot;@&quot;);</span>
                        // e.g. serviceHostname := &quot;myhost.foo.com&quot;
<span class="nc" id="L74">                        final String serviceHostname = serviceHostnameAndKerbDomain.substring(0,indexOf);</span>

<span class="nc" id="L76">                        final String mech = &quot;GSSAPI&quot;;   // TODO: should depend on zoo.cfg specified mechs, but if subject is non-null, it can be assumed to be GSSAPI.</span>

<span class="nc" id="L78">                        LOG.debug(&quot;serviceHostname is '&quot;+ serviceHostname + &quot;'&quot;);</span>
<span class="nc" id="L79">                        LOG.debug(&quot;servicePrincipalName is '&quot;+ servicePrincipalName + &quot;'&quot;);</span>
<span class="nc" id="L80">                        LOG.debug(&quot;SASL mechanism(mech) is '&quot;+ mech +&quot;'&quot;);</span>

<span class="nc" id="L82">                        boolean usingNativeJgss =</span>
<span class="nc" id="L83">                        		Boolean.getBoolean(&quot;sun.security.jgss.native&quot;);</span>
<span class="nc bnc" id="L84" title="All 2 branches missed.">                        if (usingNativeJgss) {</span>
                        	// http://docs.oracle.com/javase/6/docs/technotes/guides/security/jgss/jgss-features.html
                        	// &quot;&quot;&quot;
                        	// In addition, when performing operations as a particular
                        	// Subject, e.g. Subject.doAs(...) or
                        	// Subject.doAsPrivileged(...), the to-be-used
                        	// GSSCredential should be added to Subject's
                        	// private credential set. Otherwise, the GSS operations
                        	// will fail since no credential is found.
                        	// &quot;&quot;&quot;
                        	try {
<span class="nc" id="L95">                        		GSSManager manager = GSSManager.getInstance();</span>
<span class="nc" id="L96">                        		Oid krb5Mechanism = new Oid(&quot;1.2.840.113554.1.2.2&quot;);</span>
<span class="nc" id="L97">                        		GSSName gssName = manager.createName(</span>
                        				servicePrincipalName + &quot;@&quot; + serviceHostname,
                        				GSSName.NT_HOSTBASED_SERVICE);
<span class="nc" id="L100">                        		GSSCredential cred = manager.createCredential(gssName,</span>
                        				GSSContext.DEFAULT_LIFETIME,
                        				krb5Mechanism,
                        				GSSCredential.ACCEPT_ONLY);
<span class="nc" id="L104">                        		subject.getPrivateCredentials().add(cred);</span>
<span class="nc bnc" id="L105" title="All 2 branches missed.">                        		if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L106">                        			LOG.debug(&quot;Added private credential to subject: &quot; + cred);</span>
                        		}
<span class="nc" id="L108">                        	} catch (GSSException ex) {</span>
<span class="nc" id="L109">                        		LOG.warn(&quot;Cannot add private credential to subject; &quot; +</span>
                        				&quot;clients authentication may fail&quot;, ex);
<span class="nc" id="L111">                        	}</span>
                        }
                        try {
<span class="nc" id="L114">                            return Subject.doAs(subject,new PrivilegedExceptionAction&lt;SaslServer&gt;() {</span>
                                public SaslServer run() {
                                    try {
                                        SaslServer saslServer;
<span class="nc" id="L118">                                        saslServer = Sasl.createSaslServer(mech, servicePrincipalName, serviceHostname, null, login.callbackHandler);</span>
<span class="nc" id="L119">                                        return saslServer;</span>
                                    }
<span class="nc" id="L121">                                    catch (SaslException e) {</span>
<span class="nc" id="L122">                                        LOG.error(&quot;Zookeeper Server failed to create a SaslServer to interact with a client during session initiation: &quot; + e);</span>
<span class="nc" id="L123">                                        e.printStackTrace();</span>
<span class="nc" id="L124">                                        return null;</span>
                                    }
                                }
                            }
                            );
                        }
<span class="nc" id="L130">                        catch (PrivilegedActionException e) {</span>
                            // TODO: exit server at this point(?)
<span class="nc" id="L132">                            LOG.error(&quot;Zookeeper Quorum member experienced a PrivilegedActionException exception while creating a SaslServer using a JAAS principal context:&quot; + e);</span>
<span class="nc" id="L133">                            e.printStackTrace();</span>
                        }
                    }
<span class="nc" id="L136">                    catch (IndexOutOfBoundsException e) {</span>
<span class="nc" id="L137">                        LOG.error(&quot;server principal name/hostname determination error: &quot;, e);</span>
<span class="nc" id="L138">                    }</span>
                }
                else {
                    // JAAS non-GSSAPI authentication: assuming and supporting only DIGEST-MD5 mechanism for now.
                    // TODO: use 'authMech=' value in zoo.cfg.
                    try {
<span class="fc" id="L144">                        SaslServer saslServer = Sasl.createSaslServer(&quot;DIGEST-MD5&quot;,&quot;zookeeper&quot;,&quot;zk-sasl-md5&quot;,null, login.callbackHandler);</span>
<span class="fc" id="L145">                        return saslServer;</span>
                    }
<span class="nc" id="L147">                    catch (SaslException e) {</span>
<span class="nc" id="L148">                        LOG.error(&quot;Zookeeper Quorum member failed to create a SaslServer to interact with a client during session initiation&quot;, e);</span>
                    }
                }
            }
<span class="nc" id="L152">        }</span>
<span class="nc" id="L153">        LOG.error(&quot;failed to create saslServer object.&quot;);</span>
<span class="nc" id="L154">        return null;</span>
    }

    public byte[] evaluateResponse(byte[] response) throws SaslException {
<span class="fc" id="L158">        return saslServer.evaluateResponse(response);</span>
    }

    public boolean isComplete() {
<span class="fc" id="L162">        return saslServer.isComplete();</span>
    }

    public String getAuthorizationID() {
<span class="fc" id="L166">        return saslServer.getAuthorizationID();</span>
    }

}




</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>